//The Alabastor Box script by D00D64
//Feel free to use or reuse for whatever, but give credit!

//set up and reset variables

freeslot(
"MT_ALABASTERBOX",
"MT_SOULHEART_ICON",
"MT_HOLYSHIELD",
"MT_HOLYSHIELD2",
"MT_HOLYSHIELDBROKEN",
"SPR_ABXP",
"SPR_ABXF",
"SPR_TVSL",
"SPR_TROC",
"SPR_NOCA",
"SPR_HLYS",
"SPR_ALGZ",
"S_SOULH_ICON1",
"S_SOULH_ICON2",
"S_HOLYSHIELD_SPAWN",
"S_HOLYSHIELD2_SPAWN",
"S_HOLYSHIELD_STAND",
"S_HOLYSHIELD2_STAND",
"S_HOLYSHIELD_BREAK",
"S_ALABOXSTAND"
)

//Set up Alabaster Box on level load

addHook("PlayerSpawn", function()
	for player in players.iterate
		if(player.alabastervars == nil)
			player.alabasterars = {}
		end
		
		if(player.alaboxheld == nil)
			player.alaboxheld = false
		end
		
		if(player.chariotcard == nil)
			player.chariotcard = 0
		end
		
		if(player.chariotboost == nil)
			player.chariotboost = 0
		end
		
		if(player.holyshield == nil)
			player.holyshield = 0
		end
	end
end)

//Alabaster Box Charge

rawset(_G, "alaboxcharge", 0)
rawset(_G, "alaboxopen", 0)

addHook("GameQuit", function()
	alaboxcharge = 0
	alaboxopen = 0
end)

addHook("ThinkFrame", function(v)
	if (alaboxcharge < 0) //Alabaser Box charge count limitations
		alaboxcharge = 0
	elseif (alaboxcharge > 12)
		alaboxcharge = 12
	end
	
	if (alaboxcharge == 12) //When at max, start opening the box! 
	and (alaboxopen == 0)		
		S_StartSound(nil, sfx_bois10, player) //Battery Charged!
		alaboxopen = 18 //Takes about half a second...
	end
	
	if (alaboxopen > 0) //When the count is coming down...
		alaboxopen = $ - 1 //reduce the Opening count by 1 every tic
	end
	
	if (alaboxopen == 1) //The point where the box opens!
		alaboxcharge = 0 //Take the charges away
		for player in players.iterate
			player.alaboxheld = false //as well as the box itself!
			if player.holyshield == 0 //Don't have a Holy Shield?
				player.holyshield = 1 //Give them one!
			end
			if not (emeralds & EMERALD1) //I took this from Golden Shine's Metroid Vanguard mod and just changed names around lol - it was marked as reusable so doing this is OK
				player.lives = $ + 1 //Give the player lives as well as the next emerald
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD1) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD2)
				player.lives = $ + 1
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD2) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD3)
				player.lives = $ + 1
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD3) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD4)
				player.lives = $ + 2 //lives earned go up at specific emerald counts
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD4) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD5)
				player.lives = $ + 2
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD5) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD6)
				player.lives = $ + 3
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD6) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
			elseif not (emeralds & EMERALD7)
				player.lives = $ + 3
				player.gemget = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EMERALD7) player.gemget.momx=player.mo.momx player.gemget.momy=player.mo.momy player.gemget.momz=player.mo.momz
				if not (player.charflags & SF_SUPER) //If you can't turn super...
					if player.chariotcard == 0 //If they don't have The Chariot card...
						player.chariotcard = 1 //Give them The Chariot card!
						S_StartSound(nil, sfx_bois09)//"Card Turn"
					elseif player.chariotcard > 0 //if they have the card already...
						player.chariotboost = 702 //Give them the Chariot effect!
					end
				end
			else
				player.lives = $ + 1
				if (player.charflags & SF_SUPER) //if you can turn super...
					S_StartSound(nil, sfx_bois03)//Super Holy!
					player.rings = $ + 50 //Give them bonus rings!
				else //If you can't turn super...
					if player.chariotcard == 0 //If they don't have The Chariot card...
						player.chariotcard = 1 //Give them The Chariot card!
						S_StartSound(nil, sfx_bois09)//"Card Turn"
					elseif player.chariotcard > 0 //if they have the card already...
						player.chariotboost = 702 //Give them the Chariot effect!
					end
				end
			end
		end
	end
	
	for player in players.iterate
		if player.chariotcard //The Chariot Card stuff
			and player.chariotcard > 1 //If you somehow get another card...
			player.chariotcard = 1 //Too bad, only one at a time!
		end
		
		if player.chariotboost > 0 //The Chariot timer
			if player.chariotboost == 702 //Start the Chariot effect here!
				player.powers[pw_sneakers] = 20*TICRATE
				player.powers[pw_invulnerability] = 20*TICRATE
				S_StartSound(nil, sfx_bois11, player)//"The Chariot!"
				if player.powers[pw_super] == 0 //Not Super?
					S_ChangeMusic("_INV", false, player) //Play music!
				end
			end
			player.chariotboost = $ - 1
		elseif player.chariotboost == 1 //End the Chariot effect
		and not player.powers[pw_sneakers] > 0
		and not player.powers[pw_invulnerability] > 0
		and player.powers[pw_super] == 0
			P_RestoreMusic(player) //change music back
		end
		
		if player.charflags & SF_SUPER //If they're using a Super-capable character...
			if player.chariotboost > 1 //and under the effect (as in, mid-use character change)
				player.chariotboost = 1 //instantly end Chariot effect. Nice try!
			end
		end
		
		if player.chariotcard >= 1 //You got a Chariot card?
		and player.cmd.buttons&BT_JUMP//If holding jump..
		and player.cmd.buttons&BT_USE//and spin...
		and not player.spectator//and isn't spectating...
		and not P_PlayerInPain(player)//and not in your painstate...
		and player.mo.health//and isn't dead...
			player.chariotboost = 702 //(Finally) give them the boost!
			player.chariotcard = 0 //and use up the card
		end
		
		if player.holyshield //The Holy Shield stuff
		and player.holyshield > 1
			player.holyshield = 1 //Sorry, only one layer at a time!
		end
		
		if player.holyshield == 1//Have the shield?
			if not player.mo.holyshielded//Is it not visible?
				player.mo.holyshielded = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_HOLYSHIELD) //then make it so!
				player.mo.holyshielded.target = player.mo //Make the new object the target for the player!
			end
		end
		
		if player.holyshield == 0//Don't have the shield?
			if player.mo.holyshielded//Is it visible?
				P_RemoveMobj(player.mo.holyshielded) //then get rid of it!
				player.mo.holyshielded = nil
			end
		end
		
	end
end)


//Alabaster Box Get

addHook("TouchSpecial", function(special, toucher)
	
	if (toucher.player.alaboxheld == true)//Already have a box?
		alaboxcharge = $ + 3 //give charges
		S_StartSound(nil, sfx_bois02, player)
		return
	else //don't have the box?
		toucher.player.alaboxheld = true //you do now!
		S_StartSound(nil, sfx_bois04, player)
		if All7Emeralds(emeralds) //Do you have all those Chaos Emeralds already?
			alaboxcharge = 12 //Then max the charge right away!
		end
		return
	end
end, MT_ALABASTERBOX)

//Replace tokens with Alabaster Box

addHook("MapLoad", function(mobj)
	for mobj in mobjs.iterate()
		if mobj.type == MT_TOKEN
			mobj.type = MT_ALABASTERBOX
			mobj.state = S_ALABOXSTAND
		end
	end
end)

//Monitors charge the Alabaster Box!
//Set the Monitor table for monitors of differing worth!

if not alabastertable
	rawset(_G, "alabastertable", {})
end

alabastertable[MT_RING_BOX] = 1
alabastertable[MT_PITY_BOX] = 1
alabastertable[MT_EGGMAN_BOX] = 2
alabastertable[MT_SCORE1K_BOX] = 1
alabastertable[MT_SCORE10K_BOX] = 2
alabastertable[MT_ATTRACT_BOX] = 2
alabastertable[MT_FORCE_BOX] = 2
alabastertable[MT_ARMAGEDDON_BOX] = 2
alabastertable[MT_WHIRLWIND_BOX] = 2
alabastertable[MT_ELEMENTAL_BOX] = 2
alabastertable[MT_SNEAKERS_BOX] = 2
alabastertable[MT_FLAMEAURA_BOX] = 2
alabastertable[MT_BUBBLEWRAP_BOX] = 2
alabastertable[MT_THUNDERCOIN_BOX] = 2
alabastertable[MT_1UP_BOX] = 3
alabastertable[MT_INVULN_BOX] = 3
alabastertable[MT_MYSTERY_BOX] = 3

//Monitor charging function!

addHook("MobjDeath", function(mobj, inflictor, source)

	if not (mobj.flags & MF_MONITOR)// Don't do anything if its not a monitor!
		return
	end
	
	if (mobj.flags & MF_MONITOR) //Okay, so it IS a monitor?
		if mobj.type == MT_GRAVITY_BOX //Probably best leave this one alone...
			return
		end
		if not (mobj.flags & MF_GRENADEBOUNCE) //Is it NOT gold? Gold ones have grenadebounce for some reason??
			if (source.player.alaboxheld == true) //Holding the Alabaster Box?
				alaboxcharge = $ + alabastertable[mobj.type] //Give charge based on the worth of the monitor!
				S_StartSound(mobj, sfx_pop)
				S_StartSound(nil, sfx_bois02)// Holy!
				P_SpawnMobjFromMobj(mobj, 0, 0, mobj.height/4, MT_EXPLODE)//Emulate monitor poping
				mobj.state = S_BOX_POP2
				mobj.flags = $ & ~MF_SOLID
				return true
			end
		end
	end
end)

//Holy shield protection!

addHook("MobjThinker", function(mo) //rotating outer border
	if mo and mo.valid
		mo.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD //Makes it flat! It can rotate on its own! Otherwise, it'll always face the camera.
		mo.angle = $ + FixedAngle(16*FRACUNIT) //This makes it rotate!
		if not mo.algiz //No Algiz symbol?
			mo.algiz = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HOLYSHIELD2) //Add it!
			mo.algiz.target = mo //Make the new object the target for this one!
		end
		if mo.target //Got your target?
			P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z) //Latch onto 'em!
			mo.scale = mo.target.scale/2 //copy their scale
			mo.flags2 = mo.target.flags2 //...and these flags
		end
	end
end, MT_HOLYSHIELD)

addHook("MobjThinker", function(mo)//inner Algiz symbol
	if mo and mo.valid
		mo.renderflags = $|RF_FLOORSPRITE //Makes it flat!
		if mo.target //Got your target?
			P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z) //Latch onto 'em!
			mo.scale = mo.target.scale //copy their scale
			mo.flags2 = mo.target.flags2 //...and these flags
		end
		if (not mo.target or not mo.target.valid) then //First part of the shield gone?
			P_RemoveMobj(mo) //This should go too.
		end
	end
end, MT_HOLYSHIELD2)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype) //Prevent damage!
	if target.player.holyshield
	and target.player.holyshield >= 1 //If you got the shield...
		target.player.powers[pw_flashing] = 35 //add invincibility time...
		target.player.holyshield = 0 //take away shield...
		S_StartSound(nil, sfx_bois12)// Holy Shatter
		for player in players.iterate
			player.holyshieldbreak = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_HOLYSHIELDBROKEN) //Show broken shield
			player.holyshieldbreak.target = player.mo
			player.holyshieldbreak.scale = player.mo.scale //size up to the player!
		end
		return true //...and return without changing your states! Flinch free damage!
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)//broken holy shield
	if mo.target //Got your target?
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z) //Follow them!
	end
end, MT_HOLYSHIELDBROKEN)

//Alabaster Box HUD

local function alaboxRender(v, player)
	if player.mo and player.mo.valid

		if	(player.alaboxheld == true) //Draw the Alabaster Box Charges
			v.draw(14, 60, v.cachePatch("ABXFA0"), V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS) //Box graphic
			v.drawString(88, 71, (alaboxcharge+"/12"), V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS, "right") //Charges accumulated
		end
			
		if player.chariotcard > 0
			v.draw(16, 150, v.cachePatch("TROCA0"),  V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS)//Chariot graphic
			if player.charflags & SF_SUPER
				v.draw(16, 150, v.cachePatch("NOCAA0"),  V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS) //No Use graphic
			else
				v.drawString(79, 157, ("Jump+Spin"),  V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "thin-right")
			end
		end
		
		if player.holyshield > 0
			v.draw(295, 164, v.cachePatch("HOLYCARD"), V_SNAPTORIGHT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS) //Holy Card graphic
		end
			
	end
end
hud.add(alaboxRender, "game")
	
// End script